module LoggingElf
  class UncaughtExceptionsMiddleware
    attr_accessor :logger
    def initialize(app, args = {})
      self.logger = args[:logger]
      @app = app
    end

    def call(env)
      begin
        response = @app.call env
      rescue => err
        logger.error err
        raise err
      end
      log_rack_exceptions(env)
      response
    end

    private

    def log_rack_exceptions(env)
      logger.error env['rack.exception'] if env['rack.exception']
    end
  end
end
